'''
Created on Jun 16, 2015

@author: jaga
'''
import matplotlib.pyplot as plt
import numpy as np
import time
import matplotlib.animation as animation


def first():
    x = np.arange(0, 2*np.pi, 0.01)
    y = np.sin(x)
    
    fig, axes = plt.subplots(nrows=6)
    styles = ['r-', 'g-', 'y-', 'm-', 'k-', 'c-']
    lines = [ax.plot(x, y, style)[0] for ax, style in zip(axes, styles)]
    
    fig.show()
    
    tstart = time.time()
    for i in xrange(1, 20):
        for j, line in enumerate(lines, start=1):
            line.set_ydata(np.sin(j*x + i/10.0))
        fig.canvas.draw()
    
    print 'FPS:' , 20/(time.time()-tstart)
    
    
def second():
    x = np.arange(0, 2*np.pi, 0.1)
    y = np.sin(x)

    fig, axes = plt.subplots(nrows=6)
    
    styles = ['r-', 'g-', 'y-', 'm-', 'k-', 'c-']
    def plot(ax, style):
        return ax.plot(x, y, style, animated=True)[0]
    lines = [plot(ax, style) for ax, style in zip(axes, styles)]
    
    # Let's capture the background of the figure
    backgrounds = [fig.canvas.copy_from_bbox(ax.bbox) for ax in axes]
    
    fig.show()
    
    # We need to draw the canvas before we start animating...
    fig.canvas.draw()
    
    tstart = time.time()
    for i in xrange(1, 2000):
        items = enumerate(zip(lines, axes, backgrounds), start=1)
        for j, (line, ax, background) in items:
            fig.canvas.restore_region(background)
            line.set_ydata(np.sin(j*x + i/10.0))
            ax.draw_artist(line)
            fig.canvas.blit(ax.bbox)
    
    print 'FPS:' , 2000/(time.time()-tstart)

def third():
    x = np.arange(0, 2*np.pi, 0.1)
    y = np.sin(x)
    
    fig, axes = plt.subplots(nrows=6)
    
    styles = ['r-', 'g-', 'y-', 'm-', 'k-', 'c-']
    def plot(ax, style):
        return ax.plot(x, y, style, animated=True)[0]
    lines = [plot(ax, style) for ax, style in zip(axes, styles)]
    
    def animate(i):
        for j, line in enumerate(lines, start=1):
            line.set_ydata(np.sin(j*x + i/10.0))
        return lines
    
    # We'd normally specify a reasonable "interval" here...
    ani = animation.FuncAnimation(fig, animate, xrange(1, 200), 
                                  interval=0, blit=True)
    plt.show()


if __name__ == "__main__":
    #first()
    #second()
    third()
    
    
    
    
